package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoCardapioMesPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoEmissaoCarpioMes = By.xpath("//span[text() = 'Emissão do Cardápio do Mês']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioEmissaoCardapioMes = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês']");
    By relatorioCentralizado = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Centralizado)']");
    By relatorioInativoReceita = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Cardápios com Produto Inativo na Receita']");
    By relatorioInativoReceitaGeral = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Cardápios com Produto Inativo na Receita (Geral)']");
    By relatorioDezColunas = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (10 Colunas)']");
    By relatorioCusto = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Custo)']");
    By relatorioCustoTipoPrato = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Custo Tipo de Prato)']");
    By relatorioPeriodoPagina = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Período por Página)']");
    By relatorioEmissaoCardapioMesAlergenico = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Alergênicos)']");

    By campoAgrupoamentoUnidades = By.id("NMGRUPFILI");
    By agrupamentoProdutoAcabado = By.xpath("//div[@data-zh-id=\"212974881926205441631277\"]//span[text() = '0000000001 | PRODUCAO - PRODUTO ACABADO']");

    By botaoCampoUnidadeRelCustos = By.xpath("//div[@id=\"NMFILIAL1\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidadeRelCustos = By.id("NMFILIAL1");
    By checkBoxTodasUnidades = By.id("zh-checkbox-ALLCDFILIAL");
    By todasUnidades = By.xpath("//div[@data-zh-id=\"212974881913094336941292\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");
    By campoUnidadeUnica = By.id("NMFILIAL1");
    By unidadeJabaquara = By.xpath("//div[@data-zh-id=\"212974881917058361181283\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");

    By checkBoxTodosServicos = By.id("zh-checkbox-ALLCDSERVFILI");
    By todosServicos = By.xpath("//div[@data-zh-id=\"212974881941541043571306\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoJanta = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");
    By servicoSolicitcao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO ESPECIAL']");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By campoTipoCusto = By.id("NMTPCUSTO");
    By botaoCampoTipoCusto = By.xpath("//div[@id=\"NMTPCUSTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By tipoCustoMediobrutoAtual = By.xpath("//div[@data-zh-id=\"212974881931617880511308\"]//span[text() = 'Custo Médio Bruto Atual']");
    By valorCampoTipoCusto = By.xpath("//div[@id=\"NMTPCUSTO\"]//span[@class=\"value\"]");

    By campoMesInicial = By.id("MESINICIO");
    By campoMesFinal = By.id("MESFINAL");
    By mesOutubro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Out']");
    By mesNovembro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Nov']");
    By botaoMesInicial = By.xpath("//div[@id=\"MESINICIO\"]//span[@zh-icon=\"no-border close-x\"]");
    By botaoMesFinal = By.xpath("//div[@id=\"MESFINAL\"]//span[@zh-icon=\"no-border close-x\"]");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for=\"radio-QR2TYPE-PDF\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By imprimirMensagem = By.xpath("//div[@data-zh-id=\"21297488196614135011309\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimirNomeFantasia = By.xpath("//div[@data-zh-id=\"21297488195275150871310\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimirDiasSemCardapio = By.xpath("//div[@data-zh-id=\"212974881913394873451311\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimir = By.xpath("//div[@data-zh-id=\"212974881932832875761312\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxImprimirMensagem = By.id("zh-checkbox-MENS");
    By checkBoxImprimirNomeFantasia = By.id("zh-checkbox-IMPNMFANTA");
    By checkBoxImprimirDiasSemCardapio = By.id("zh-checkbox-IMPDIASSEMCARD");
    By checkBoxImprimir = By.id("zh-checkbox-IMPCOMEN");

    By comensaisNumero = By.xpath("//label[@for=\"radio-TPIMPRESSAO-T\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\" and @contenteditable=\"true\"]");
    By comensaisPercentual = By.xpath("//label[@for=\"radio-TPIMPRESSAO-N\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\" and @contenteditable=\"true\"]");
    By radioButtonNumero = By.id("radio-TPIMPRESSAO-T");
    By radioButtonPercentual = By.id("radio-TPIMPRESSAO-N");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"212974881935456362811288\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeRelCustos = By.xpath("//div[@data-zh-id=\"212974881917058361181283\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"212974881923042825861299\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesInicial = By.xpath("//div[@data-zh-id=\"212974881920701616591294\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatoiroMesFinal = By.xpath("//div[@data-zh-id=\"212974881924362402271296\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCusto = By.xpath("//div[@data-zh-id=\"212974881931617880511308\"]//div[@class=\"zh-validation\"]/span");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão do Cardápio do Mês");
        click(selecionarOpcaoEmissaoCarpioMes);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        if (nomeRelatorio == "Emissão do Cardápio do Mês") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioEmissaoCardapioMes);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Centralizado)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCentralizado);
        } else if (nomeRelatorio == "Cardápios com Produto Inativo na Receita") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioInativoReceita);
        } else if (nomeRelatorio == "Cardápios com Produto Inativo na Receita (Geral)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioInativoReceitaGeral);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (10 Colunas)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioDezColunas);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Custo)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCusto);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Custo Tipo de Prato)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCustoTipoPrato);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Período por Página)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPeriodoPagina);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Alergênicos)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioEmissaoCardapioMesAlergenico);
        }
    }

    public void selecionarAgrupamento() {
        clicarCampoSelecionarValor(campoAgrupoamentoUnidades, agrupamentoProdutoAcabado);
    }

    public void selecionarUnidadeDepositoBc129() {
            click(todasUnidades);
            click(campoUnidade);
            click(unidadeDepositoBc129);
            click(botaoOk);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoJanta);
        click(servicoSolicitcao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarUnidadeEServicosJabaquara() {
        clicarCampoSelecionarValor(campoUnidadeUnica, unidadeJabaquara);
        click(todosServicos);
        click(campoServico);
        click(servicoRetiradas);
        click(servicoAlmocoEspecial);
        click(botaoOk);
    }

    public void selecionarMeses() {
        clicarCampoSelecionarValor(campoMesInicial, mesOutubro);
        clicarCampoSelecionarValor(campoMesFinal, mesNovembro);
    }

    public void selecionarTipoDeCusto() {
        clicarCampoSelecionarValor(campoTipoCusto, tipoCustoMediobrutoAtual);
        String tipoCusto = getText(valorCampoTipoCusto);
        Assert.assertEquals(tipoCusto, "Custo Médio Bruto Atual", "Verificar o valor apresentado no campo tipo de custo, após selecionar o tipo de custo desejado");
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void mesInicialMaiorQueFinal() {
        clicarCampoSelecionarValor(campoMesInicial, mesNovembro);
        clicarCampoSelecionarValor(campoMesFinal, mesOutubro);
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "O mês inicial deve ser menor ou igual ao mês final.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar gerar um relatório com o mês inicial maior que o final");
        click(botaoOkAlerta);
    }

    public void camposObrigatorios() {
        List<String> relatorios = listaRelatorios();

        for (String rel : relatorios) {
            selecionarRelatorio(rel);
            tempo();

            String mensagemEsperada = "Campo obrigatório";
            String unidade;
            String servico;
            String mesInicial;
            String mesFinal;
            String tipoCusto;

            click(todosServicos);
            click(botaoMesInicial);
            click(botaoMesFinal);

            //apenas os 2 relatórios presentes no if possuem o campo que pode selecionar apenas uma unidade, dessa forma é necessário clicar no botão deste campo para deixá-lo vazio
            //além deste campo unidade, é necessário clicar também no botão do tipo de custo para deixá-lo vazio
            //como a forma de verificar a mensagem de campo obrigatório no campo unidade é igual em todos os relatórios
            //o que muda é apenas a forma de captura a mensagem, sendo assim a mensagem será gerada, ecaptura, mas será verificada juntamente com o serviço, meses...
            //já o tipo de custo será geradado, capturado e verificado no if
            if (rel.equals("Emissão do Cardápio do Mês (Custo)") || rel.equals("Emissão do Cardápio do Mês (Custo Tipo de Prato)")) {
                click(botaoCampoUnidadeRelCustos);
                click(botaoCampoTipoCusto);
                click(botaoRelatorio);
                unidade = getText(mensagemObrigatorioUnidadeRelCustos);
                tipoCusto = getText(mensagemObrigatorioTipoCusto);
                Assert.assertEquals(tipoCusto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo tipo de custo, com o seguinte relatório selecionado: " + rel);
            } else if (rel.equals("Emissão do Cardápio do Mês (Período por Página)")) {
                //o relatório Emissão do Cardápio do Mês (Período por Página) diferente dos demais relatório ele possuí o tipo de custo e é possível selecionar mais de uma unidade
                //sendo assim a mensagem de unidade será gerada, captura, mas verificada juntamente com serviço, meses..
                //já o tipo de custo será geradado, capturado e verificado neste else if
                click(botaoCampoTipoCusto);
                click(botaoRelatorio);
                unidade = getText(mensagemObrigatorioUnidade);
                tipoCusto = getText(mensagemObrigatorioTipoCusto);
                Assert.assertEquals(tipoCusto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo tipo de custo, com o seguinte relatório selecionado: " + rel);
            } else {
                click(botaoRelatorio);
                unidade = getText(mensagemObrigatorioUnidade); //nos demais relatórios é necessário apenas gerar a mensagem de unidade e capturada para verificar juntamente com serviço, meses...
            }

            servico = getText(mensagemObrigatorioServico);
            mesInicial = getText(mensagemObrigatorioMesInicial);
            mesFinal = getText(mensagemObrigatoiroMesFinal);

            Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo unidade, com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo serviço, com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(mesInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo mês inicial, com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(mesFinal, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo mês final, com o seguinte relatório selecionado: " + rel);

            refresh();
            tempo();
            tempo();
        }
    }

    public void camposHabilitados() {
        List<String> relatorios = listaRelatorios();

        for (String rel : relatorios) {
            selecionarRelatorio(rel);
            tempo();

            boolean unidade;
            boolean agrupamentoUnidades = returnIfClassDisable(campoAgrupoamentoUnidades);
            boolean servico = returnIfElementIsEnabled(checkBoxTodosServicos);
            boolean mesInicial = returnIfClassDisable(campoMesInicial);
            boolean mesFinal = returnIfClassDisable(campoMesFinal);
            boolean tipoCusto = returnIfClassDisable(campoTipoCusto);
            boolean imprimirMensagem = returnIfElementIsEnabled(checkBoxImprimirMensagem);
            boolean imprimirNomeFantasia = returnIfElementIsEnabled(checkBoxImprimirNomeFantasia);
            boolean imprimirDiasSemCardapio = returnIfElementIsEnabled(checkBoxImprimirDiasSemCardapio);
            boolean imprimir = returnIfElementIsEnabled(checkBoxImprimir);
            boolean numero = returnIfElementIsEnabled(radioButtonNumero);
            boolean percentual = returnIfElementIsEnabled(radioButtonPercentual);


            switch (rel) {
                //nestes 2 relatórios a unidade é apenas uma opção, dessa forma a unidade é um campo e não uma lista como os demais relatórios
                //por conta disso o método para verificação é diferente. E também apenas deste 2 relatórios, o agrupamento de unidades devem estar desabilitado
                //a verificação da unidade é juntamente com os campos serviço, meses... juntamente com os demais serviço, a únidade diferença é a for de pegar se o campo é habilitado ou não, já a for de verificar é a mesma
                case "Emissão do Cardápio do Mês (Custo)":
                case "Emissão do Cardápio do Mês (Custo Tipo de Prato)":
                    unidade = returnIfClassDisable(campoUnidadeRelCustos);
                    Assert.assertFalse(agrupamentoUnidades, "Verificar se o campo agrupamento de unidades está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                //nos demais relatórios o método de verificar se a unidade está habilitado ou não é diferente dos 2 anteriores e o agrupamento de unidade deve estar habilitado em todos
                default:
                    unidade = returnIfElementIsEnabled(checkBoxTodasUnidades);
                    Assert.assertTrue(agrupamentoUnidades, "Verificar se o campo agrupamento de unidades está habilitado com o seguinte relatório selecionado: " + rel);
                    break;
            }


            //a unidade, o serviço, mês inicial, mês final e imprimir nome fantasia são opções que devem estar habilitadas para todos os relatórios
            Assert.assertTrue(unidade, "Verificar se o campo unidade de custo está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(servico, "Verificar se o campo serviço está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(mesInicial, "Verificar se o campo mês inicial está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(mesFinal, "Verificar se o campo mês final está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(imprimirNomeFantasia, "Verificar se o check-box imprimir nome fantasia está habilitado com o seguinte relatório selecionado: " + rel);


            switch (rel) {
                //as seguintes opções estão desabilitadas: tipo de custo
                case "Emissão do Cardápio do Mês":
                case "Emissão do Cardápio do Mês (Alergênicos)":
                    Assert.assertFalse(tipoCusto, "Verificar se o campo tipo de custo está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirMensagem, "Verificar se o check-box imprimir mensagem está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirDiasSemCardapio, "Verificar se o check-box imprimir dias sem cardápio está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimir, "Verificar se o check-box imprimir está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(numero, "Verificar se o radio-button número está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(percentual, "Verificar se o radio-button percentual está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                //as seguintes opções estão desabilitadas: tipo de custo, imprimir, número e percentual
                case "Emissão do Cardápio do Mês (Centralizado)":
                case "Emissão do Cardápio do Mês (10 Colunas)":
                    Assert.assertFalse(tipoCusto, "Verificar se o campo tipo de custo está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirMensagem, "Verificar se o check-box imprimir mensagem está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirDiasSemCardapio, "Verificar se o check-box imprimir dias sem cardápio está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(imprimir, "Verificar se o check-box imprimir está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(numero, "Verificar se o radio-button número está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(percentual, "Verificar se o radio-button percentual está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                //as seguintes opções estão desabilitadas: tipo de custo, imprimir mensagem, imprimir, número e percentual
                case "Cardápios com Produto Inativo na Receita":
                case "Cardápios com Produto Inativo na Receita (Geral)":
                    Assert.assertFalse(tipoCusto, "Verificar se o campo tipo de custo está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(imprimirMensagem, "Verificar se o check-box imprimir mensagem está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirDiasSemCardapio, "Verificar se o check-box imprimir dias sem cardápio está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(imprimir, "Verificar se o check-box imprimir está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(numero, "Verificar se o radio-button número está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(percentual, "Verificar se o radio-button percentual está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                //as seguintes opções estão desabilitadas: imprimir dias sem cardápio, imprimir, número e percentual
                case "Emissão do Cardápio do Mês (Período por Página)":
                    Assert.assertTrue(tipoCusto, "Verificar se o campo tipo de custo está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirMensagem, "Verificar se o check-box imprimir mensagem está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(imprimirDiasSemCardapio, "Verificar se o check-box imprimir dias sem cardápio está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(imprimir, "Verificar se o check-box imprimir está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(numero, "Verificar se o radio-button número está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(percentual, "Verificar se o radio-button percentual está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                //os seguintes relatórios possuem todos os campos da tela habilitados exceto o agrupamento de unidades que já foi verificado anteriormente
                case "Emissão do Cardápio do Mês (Custo)":
                case "Emissão do Cardápio do Mês (Custo Tipo de Prato)":
                    Assert.assertTrue(tipoCusto, "Verificar se o campo tipo de custo está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirMensagem, "Verificar se o check-box imprimir mensagem está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimirDiasSemCardapio, "Verificar se o check-box imprimir dias sem cardápio está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(imprimir, "Verificar se o check-box imprimir está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(numero, "Verificar se o radio-button número está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(percentual, "Verificar se o radio-button percentual está habilitado com o seguinte relatório selecionado: " + rel);
                    break;
            }
            tempo();
        }

    }

    public void marcarDesmarcarCheckBoxsERadioButtons() {
        //verificação dos parâmentros já selecionados ao acessar a tela com o relatório Emissão do Cardápio do Mês já selecionado
        boolean checkTodasUnidades = returnIfElementIsSelected(checkBoxTodasUnidades);
        boolean checkTodosServicos = returnIfElementIsSelected(checkBoxTodosServicos);
        boolean checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        boolean checkImprimirNomeFantasia = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        boolean checkImprimirDiasSemCard = returnIfElementIsSelected(checkBoxImprimirDiasSemCardapio);
        boolean checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        boolean radioButNumero = returnIfElementIsSelected(radioButtonNumero);
        boolean radioButPercentual = returnIfElementIsSelected(radioButtonPercentual);
        Assert.assertFalse(checkTodasUnidades, "Verificar se o check-box todas unidades não está selecionado");
        Assert.assertTrue(checkTodosServicos, "Verificar se o check-box todos serviços está selecionado");
        Assert.assertFalse(checkImprimirMensagem, "Verificar se o check-box imprimir mensagem não está selecionado");
        Assert.assertFalse(checkImprimirNomeFantasia, "Verificar se o check-box imprimir nome fantasia não está selecionado");
        Assert.assertTrue(checkImprimirDiasSemCard, "Verificar se o check-box imprimir dias sem cardápio está selecionado");
        Assert.assertTrue(checkImprimir, "Verificar se o check-box imprimir está selecionado");
        Assert.assertTrue(radioButNumero, "Verificar se o radio-button número está selecionado");
        Assert.assertFalse(radioButPercentual, "Verificar se o radio-button percentual não está selecionado");

        //clicar nos check-box para verificar se os que não estão selecionado passão a estar selecionados e os que estão selecionados passam a não estar mais
        //verificar se com o check-box imprimir não estando selecionado, as opções número e percentual passam a estar desabilitadas
        click(todasUnidades);
        click(todosServicos);
        click(imprimirMensagem);
        click(imprimirNomeFantasia);
        click(imprimirDiasSemCardapio);
        click(imprimir);
        checkTodasUnidades = returnIfElementIsSelected(checkBoxTodasUnidades);
        checkTodosServicos = returnIfElementIsSelected(checkBoxTodosServicos);
        checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        checkImprimirNomeFantasia = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        checkImprimirDiasSemCard = returnIfElementIsSelected(checkBoxImprimirDiasSemCardapio);
        checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        radioButNumero = returnIfElementIsEnabled(radioButtonNumero);
        radioButPercentual = returnIfElementIsEnabled(radioButtonPercentual);
        Assert.assertTrue(checkTodasUnidades, "Verificar se após clicar na opção todas do campo unidade, o check-box passa a estar selecionado");
        Assert.assertFalse(checkTodosServicos, "Verificar se após clicar na opção todos do campo serviço, o check-box passa a não estar mais selecionado");
        Assert.assertTrue(checkImprimirMensagem, "Verificar se após clicar na opção imprimir mensagem, o check-box da mesma passa a estar selecionado");
        Assert.assertTrue(checkImprimirNomeFantasia, "Verificar se após clicar na opção imprimir nome fantasia, o check-box da mesma passa a estar selecionado");
        Assert.assertFalse(checkImprimirDiasSemCard, "Verificar se após clicar na opção imprimir dias sem cardápio, o check-box passa a não estar mais selecionado");
        Assert.assertFalse(checkImprimir, "Verificar se após clicar na opção imprimir, o check-box passa a não estar mais selecionado");
        Assert.assertFalse(radioButNumero, "Verificar se após desmarcar o check-box imprimir, o radio-botton do número passa a estar desabilitado");
        Assert.assertFalse(radioButPercentual, "Verificar se após desmarcar o check-box imprimir, o radio-botton do percentual passa a estar desabilitado");

        //verificar se ao marcar a opção imprimir, as opções (número e percentual) de comensais passar a estar habilitados e sendo assim é possível marcar percentual
        click(imprimir);
        checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        radioButNumero = returnIfElementIsEnabled(radioButtonNumero);
        radioButPercentual = returnIfElementIsEnabled(radioButtonPercentual);
        Assert.assertTrue(checkImprimir, "Verificar se o check-box imprimir está selecionado");
        Assert.assertTrue(radioButNumero, "Verificar se com o check-box imprimir selecionado a opção número passa a estar habilitada");
        Assert.assertTrue(radioButPercentual, "Verificar se com o check-box imprimir selecionado a opção percentual passa a estar habilitada");

        click(comensaisPercentual);
        radioButNumero = returnIfElementIsSelected(radioButtonNumero);
        radioButPercentual = returnIfElementIsSelected(radioButtonPercentual);
        Assert.assertTrue(radioButPercentual, "Verificar se após clicar na opção percentual, a mesma passa a estar selecionada");
        Assert.assertFalse(radioButNumero, "Verificar se após clicar na opção percentual, a opção número passa a não estar mais selecionada");

        click(comensaisNumero);
        radioButNumero = returnIfElementIsSelected(radioButtonNumero);
        radioButPercentual = returnIfElementIsSelected(radioButtonPercentual);
        Assert.assertFalse(radioButPercentual, "Verificar se após clicar na opção número, a opção percentual passa a não estar mais selecionada");
        Assert.assertTrue(radioButNumero, "Verificar se após clicar na opção número, a mesma passa a estar selecionada");
    }

    private List<String> listaRelatorios() {
        List<String> relatorios = new ArrayList<>();

        relatorios.add("Emissão do Cardápio do Mês");
        relatorios.add("Emissão do Cardápio do Mês (Centralizado)");
        relatorios.add("Cardápios com Produto Inativo na Receita");
        relatorios.add("Cardápios com Produto Inativo na Receita (Geral)");
        relatorios.add("Emissão do Cardápio do Mês (10 Colunas)");
        relatorios.add("Emissão do Cardápio do Mês (Custo)");
        relatorios.add("Emissão do Cardápio do Mês (Custo Tipo de Prato)");
        relatorios.add("Emissão do Cardápio do Mês (Período por Página)");
        relatorios.add("Emissão do Cardápio do Mês (Alergênicos)");

        return relatorios;
    }

    private boolean returnIfClassDisable(By campo) {
        return !driver.findElement(campo).getAttribute("class").contains("zh-disabled");
    }

}