package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class NutrientesCardapioPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaNutrientesCardapio = By.xpath("//span[text() = 'Nutrientes do Cardápio']");

    By campoRelatorio = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAnaliticoData = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Analítico por Data)']");
    By relatorioAnaliticoServico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Analítico por Serviço)']");
    By relatorioSinteticoData = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Sintético por Data)']");
    By relatorioSinteticoServico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Sintético por Serviço)']");
    By relatorioColuna = By.xpath("//ul[@class='list zh-new-select-list']//li[text()='Nutrientes do Cardápio (Coluna)']");
    By relatorioEtiqueta = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Etiqueta)']");
    By relatorioPorGrupoNutrientes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio ( por Grupo de Nutrientes)']");

    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");

    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");

    By todoServicos = By.xpath("//div[@data-zh-id='103985514241080510764663']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'DISTRIBUICAO']");

    By todosNutrientes = By.xpath("//div[@data-zh-id='103985514227776731854668']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoNutrientes = By.id("NMNUTRIENTE");
    By nutrienteVitaminaA = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'VITAMINA A']");
    By nutrienteVitaminaD = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'VITAMINA D']");
    By nutrienteVitaminaComplexoB = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'VITAMINA COMPLEXO B']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"103985514240438253704652\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioIntervaloData = By.xpath("//div[@data-zh-id=\"103985514214851082531909\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1039855142739871074659\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNutriente = By.xpath("//div[@data-zh-id=\"103985514226365359724665\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"10398551429089960374670\"]//div[@class=\"zh-validation\"]/span");

    By todosTipoPrato = By.xpath("//div[@data-zh-id='103985514232289474134673']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoPrincipal = By.xpath("//div[@data-zh-field-name='NMTIPOPRAT']//span[text() = 'PRATO PRINCIPAL']");
    By tipoPratosFeijao = By.xpath("//div[@data-zh-field-name='NMTIPOPRAT']//span[text() = 'FEIJAO']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");

    By checkBoxTodosServicos = By.id("zh-checkbox-ALLCDSERVFILI");
    By checkBoxTodosNutrientes = By.id("zh-checkbox-ALLCDNUTRIENTE");
    By checkBoxTodosTipoPrato = By.id("zh-checkbox-ALLCDTIPOPRATO");

    By campoImprimirOpcoes = By.xpath("//label[@for=\"zh-checkbox-TODASOPCAO\" and @class=\"zh-box-label\"]");
    By campoImprimirNDPCal = By.xpath("//label[@for=\"zh-checkbox-DSIMPNDPCAL\" and @class=\"zh-box-label\"]");
    By campoNutrienteHabilitado = By.xpath("//label[@for=\"zh-checkbox-ALLCDNUTRIENTE\" and @class=\"zh-box-label\"]");
    By checkBoxImprimirOpcoes = By.id("zh-checkbox-TODASOPCAO");
    By checkBoxImprimirNDPCal = By.id("zh-checkbox-DSIMPNDPCAL");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoSimDesejaContinuar = By.xpath("//footer[@class='zh-footer-alert']//span[text()='Sim']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']/div");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");

     public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes do Cardápio");
        click(opcaoTelaNutrientesCardapio);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        tempo();
        tempo();

        switch (nomeDoRelatorio) {
            case "Nutrientes do Cardápio (Analítico por Data)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoData);
                break;
            case "Nutrientes do Cardápio (Analítico por Serviço)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoServico);
                break;
            case "Nutrientes do Cardápio (Sintético por Data)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoData);
                break;
            case "Nutrientes do Cardápio (Sintético por Serviço)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoServico);
                break;
            case "Nutrientes do Cardápio (Coluna)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioColuna);
                break;
            case "Nutrientes do Cardápio (Etiqueta)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioEtiqueta);
                break;
            case "Nutrientes do Cardápio ( por Grupo de Nutrientes)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioPorGrupoNutrientes);
                break;
        }
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarServicos() {
        click(todoServicos);
        click(campoServico);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarTipoPrato() {
        click(todosTipoPrato);
        click(campoTipoPrato);
        click(tipoPratoPrincipal);
        click(tipoPratosFeijao);
        click(botaoOk);
    }

    public void selecionarNutrientes() {
        click(todosNutrientes);
        click(campoNutrientes);
        click(nutrienteVitaminaA);
        click(nutrienteVitaminaD);
        click(nutrienteVitaminaComplexoB);
        click(botaoOk);
    }

    public void geraRelatorio(String nomeRelatorio) {
        if (nomeRelatorio == "Nutrientes do Cardápio (Coluna)") {
            click(botaoRelatorio);
            String mensagem = getText(campoMensagemAlerta);
            String mensagemEsperada = "Possível gerar somente 12 colunas para nutrientes. Deseja continuar?";
            Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela antes de gerar o relatório Nutrientes do Cardápio (Coluna)");
            click(botaoSimDesejaContinuar);
            click(tipoPdf);
            click(botaoConfirmar);
        } else if (nomeRelatorio == "Nutrientes do Cardápio ( por Grupo de Nutrientes)") {
            click(botaoRelatorio);
            tempo();
            String mensagem = getText(campoMensagemAlerta);
            String mensagemEsperada = "Para este relatório, somente são considerados os quatro primeiros nutrientes selecionados, ordenados pelo código. Lipídios, carboidratos, calorias e proteínas não necessitam ser selecionados.";
            Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela antes de gerar o relatório Nutrientes do Cardápio (Coluna)");
            click(botaoOkAlerta);
            click(tipoPdf);
            click(botaoConfirmar);
        } else {
            super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        }
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void verificarCamposObrigatorios(String nomeRelatorio) {
        String mensagemEsperada = "Campo obrigatório";
        String mensagemEsperadaIntervaloData = "Start and End date is Required!";

        click(botaoCampoUnidade);
        click(todoServicos);
        click(todosTipoPrato);
        if (nomeRelatorio != "Nutrientes do Cardápio (Coluna)" && nomeRelatorio != "Nutrientes do Cardápio (Etiqueta)") {
            click(todosNutrientes);
        }

        click(botaoRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String data = getText(mensagemObrigatorioIntervaloData);
        String servico = getText(mensagemObrigatorioServico);
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo unidade com o relatório " + nomeRelatorio + " selecionado");
        Assert.assertEquals(data, mensagemEsperadaIntervaloData, "Verificar mensagem de campo obrigatório no campo data com o relatório " + nomeRelatorio + " selecionado");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo serviço com o relatório " + nomeRelatorio + " selecionado");
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo tipo de prato com o relatório " + nomeRelatorio + " selecionado");

        if (nomeRelatorio != "Nutrientes do Cardápio (Coluna)" && nomeRelatorio != "Nutrientes do Cardápio (Etiqueta)") {
            String nutriente = getText(mensagemObrigatorioNutriente);
            Assert.assertEquals(nutriente, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo nutriente com o relatório " + nomeRelatorio + " selecionado");
        }
    }

    public void verificarOpcoesHabilitadasPelosRelatorios() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoData);
        boolean imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        boolean imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        boolean checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        boolean checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        boolean checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");


        clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoServico);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoData);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoServico);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioColuna);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, false, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosNutriente, false, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioEtiqueta);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, false, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosNutriente, false, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioPorGrupoNutrientes);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(imprimirNDPCal, false, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
    }



}
