package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class SetorDaCozinhaPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Setor da Cozinha']");
    By confirmaTela = By.xpath("//div[text() = 'Setor da Cozinha']");

    //Filtro unidade
    By limpaFiltroFilial = By.xpath("//div[@id = 'FILTER_FILIAL']//span[@zh-icon='no-border close-x']");
    By buscaUnidade = By.xpath("//div[@id = 'FILTER_FILIAL']//span[@zh-icon='no-border search']");
    By informaBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaUnidade = By.xpath("//div[@class = 'tr cell1']");
    By clicaUnidade9999 = By.xpath("//span[text() = '9999']");

    By btnAdicionarSetor = By.xpath("//li[@data-zh-id='4248116992768068026427']");
    By insereCodigoSetor = By.xpath("//input[@name = 'CDSETORCOZ']");
    By insereNomeSetor = By.xpath("//input[@name = 'NMSETORCOZ']");
    By btnSalvarProximo = By.xpath("//li[@data-zh-id='4248116993740526376308']//span[text() = 'Salvar e Próximo']");

    By marcaSetor = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='__CHECKBOX']");
    By clicarEditarSetor01 = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@class = 'editable-content']");
    By cliqueNomeSetor01 = By.xpath("//*[@id='grid-424811699929751648424']/div[2]/div/div[1]/div[3]/div");
    By clicarEditarSetor02 = By.xpath("//div[@class = 'tr cell2']//div[@class = 'editable-content']");
    By insereNomeSetor01 = By.xpath("//*[@id='grid-424811699929751648424']/div[2]/div/div[1]/div[3]/div/input");
    By insereNomeSetor02 = By.xpath("//*[@id='grid-424811699929751648424']/div[2]/div/div[2]/div[3]/div/input");
    By btnSalvarAlteracoes = By.xpath("//li[@data-zh-id='424811699929751648424_saveEdit']//span[text() = 'Salvar alterações']");

    By retornaCadastroSetor01 = By.xpath("//div[@id='grid-424811699929751648424']//div[@class = 'body-content']//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='NMSETORCOZ']/span");
    By retornarCadastroSetor02 = By.xpath("//div[@id='grid-424811699929751648424']//div[@class = 'body-content']//div[@class = 'tr cell2']//div[@data-zh-field-name='NMSETORCOZ']/span");

    By validarEdicaoSetor01 = By.xpath("//div[@id='grid-424811699929751648424']//div[@class = 'body-content']/div[1]//div[@data-zh-field-name='NMSETORCOZ']/span");
    By validarEdicaoSetor02 = By.xpath("//div[@id='grid-424811699929751648424']//div[@class = 'body-content']/div[2]//div[@data-zh-field-name='NMSETORCOZ']/span");
    By validarExclusaoSetor = By.xpath("//p[text() = 'Não há registros']");

    By btnExcluirSetor = By.xpath("//li[@data-zh-id='4248116991868636798433']");
    By btnConfirmarExclusao = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");

    By retornaMensagem = By.xpath("//span[text() = 'Impossível adicionar. Registro já existe.']");
    By btnOk = By.xpath("//*[@data-ng-repeat='button in buttons']");


    public void acessarTela(){
        tempo();
        //waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Setor da Cozinha");
        tempo();
        click(selecionaTela);
        tempo();
        tempo();
    }

    public String confirmaTela(){
        return getText(confirmaTela);
    }

    public void buscaUnidade(String CDUNIDADE){
        click(limpaFiltroFilial);
        tempo();
        click(buscaUnidade);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,CDUNIDADE);
        tempo();
        click(selecionaUnidade);
        tempo();
    }

    public void insereSetorCozinha(String CDSETOR, String NMSETOR){
        Actions actions = new Actions(driver);
        click(btnAdicionarSetor);
        tempo();
        click(btnSalvarProximo);
        tempo();
        actions.moveToElement(driver.findElement(insereCodigoSetor), -100, 0).click().build().perform();
        clearAndSendKeys(insereCodigoSetor,CDSETOR);
        tempo();
        clickPerform(insereNomeSetor);
        clearAndSendKeys(insereNomeSetor,NMSETOR);
        tempo();
        click(btnSalvarProximo);
        tempo();
    }

    public void validaInsercaoRegistroExistente(String CDSETOR, String NMSETOR){
        click(btnAdicionarSetor);
        tempo();
        click(insereNomeSetor);
        clearAndSendKeys(insereCodigoSetor,CDSETOR);
        tempo();
        clickPerform(insereNomeSetor);
        clearAndSendKeys(insereNomeSetor,NMSETOR);
        tempo();
        click(btnSalvarProximo);
        tempo();
    }

    public String validaCadastroSetor01(){
        return getText(retornaCadastroSetor01);
    }

    public String validaCadastroSetor02(){
        return getText(retornarCadastroSetor02);
    }

    public void editarSetor(String NMSETOR01, String NMSETOR02){
        tempo();
        click(clicarEditarSetor01);
        click(insereNomeSetor01);
        clearAndSendKeys(insereNomeSetor01,"");
        click(clicarEditarSetor02);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(cliqueNomeSetor01);
        click(insereNomeSetor01);
        clearAndSendKeys(insereNomeSetor01,NMSETOR01);
        tempo();
        click(clicarEditarSetor02);
        click(insereNomeSetor02);
        clearAndSendKeys(insereNomeSetor02,NMSETOR02);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
    }

    public String validarEdicaoSetor01(){
        return getText(validarEdicaoSetor01);
    }

    public String validarEdicaoSetor02(){
        return getText(validarEdicaoSetor02);
    }

    public void apagarSetor(){
        for (int i = 0; i < 2; i++) {
            tempo();
            click(marcaSetor);
            tempo();
            click(btnExcluirSetor);
            tempo();
            click(btnConfirmarExclusao);
            tempo();
        }
    }

    public String retornaExclusaoSetor(){return getText(validarExclusaoSetor);}

    public String retornaMensagem(){
        return getText(retornaMensagem);
    }

    public void excluirRegistroRelacionado(){
        click(limpaFiltroFilial);
        tempo();
        click(buscaUnidade);
        tempo();
        click(clicaUnidade9999);
        tempo();
        click(marcaSetor);
        click(btnExcluirSetor);
        tempo();
        click(btnConfirmarExclusao);
        tempo();
        click(btnOk);
        tempo();



    }

}
