package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.CalendarioDeCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.openqa.selenium.By;
import org.testng.Assert;
import org.testng.annotations.Test;

public class CalendarioDeCardapioTests extends TestBase {

LoginFlows loginFlows;
CalendarioDeCardapioFlows calendarioDeCardapioFlows;

    public void acessarTelaCalendario() {
    loginFlows = new LoginFlows();
    calendarioDeCardapioFlows = new CalendarioDeCardapioFlows();
    loginFlows.efetuarLogin();
    calendarioDeCardapioFlows.acessarTelaCalendarioCardapio();

    }

    @Test
    public void validaCamposObrigatorios() {
        String msgEsperada = "Campo obrigatório";
        calendarioDeCardapioFlows = new CalendarioDeCardapioFlows();
        acessarTelaCalendario();
        calendarioDeCardapioFlows.validaCamposObrigatorios();
        Assert.assertEquals(calendarioDeCardapioFlows.mensagemCampoLiberacao(),msgEsperada,"Campo Previsão de Liberação: ");
        Assert.assertEquals(calendarioDeCardapioFlows.mensagemCampoLimiteAprovUnidade(),msgEsperada,"Campo Aprovação da Unidade: ");
        Assert.assertEquals(calendarioDeCardapioFlows.mensagemCampoLimiteAprovMatriz(),msgEsperada,"Campo Aprovação da Matriz: ");


    }

    @Test
    public void insereCalendarioCardapio(){
        String DTLIBERACAO = "20/12/2024";
        String DTCUSTO = "01/12/2024";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.insereCalendarioCardapio(DTLIBERACAO,DTCUSTO);
        Assert.assertEquals(calendarioDeCardapioFlows.validaDataLiberacaoCardapio(),DTLIBERACAO,"Liberação Cardápio: ");
        Assert.assertEquals(calendarioDeCardapioFlows.validaDataCustoCardapio(),DTCUSTO,"Custo cardápio: ");
    }

    @Test
    public void insereDiasProrrogacao(){
        String NRDIASPRORROGUNIDADE = "3";
        String NRDIASPRORROGMatriz = "1";
        String NRDIASPRORROG = "5";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.diasProrrogacaoCalendario(NRDIASPRORROGUNIDADE,NRDIASPRORROGMatriz,NRDIASPRORROG);
        Assert.assertEquals(calendarioDeCardapioFlows.msgEncontradaDiasProrrogacaoUnidade(),NRDIASPRORROGUNIDADE,"Prorrogração unidade : ");
        Assert.assertEquals(calendarioDeCardapioFlows.msgEncontradaDiasProrrogacaoMatriz(),NRDIASPRORROGMatriz,"Prorrogação matriz: ");
        Assert.assertEquals(calendarioDeCardapioFlows.msgEncontradaDiasProrrogacao(),NRDIASPRORROG,"Dias prorrogação: ");
    }

    @Test
    public void calendarioBloqueadoEdicao(){
        acessarTelaCalendario();
        calendarioDeCardapioFlows.calendarioBloqueadoEdicao();

    }

    @Test
    public void validaDataAprovUnidadeAnteriorAtual(){
        String tipoProcessamento = "Filial";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.insereDataAnteriorAprovCard(tipoProcessamento);
    }

    @Test
    public void validaDataAprovMatrizAnteriorAtual(){
        String tipoProcessamento = "Matriz";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.insereDataAnteriorAprovCard(tipoProcessamento);
    }

    @Test
    public void prorrogacaoAutomaticaTodos(){
        String NRDIAS = "1";
        acessarTelaCalendario();
        String TPPRORROG = "T";
        calendarioDeCardapioFlows.prorrogacaoAutomaticaCalendario(TPPRORROG,NRDIAS);
        Assert.assertEquals(calendarioDeCardapioFlows.msgEsperadaDiasProrrogacao(),NRDIAS,"Dias prorrogação: ");;


    }

    @Test
    public void prorrogacaoAutomaticaAgrupamento(){
        String NRDIAS = "6";
        acessarTelaCalendario();
        String TPPRORROG = "A";
        calendarioDeCardapioFlows.prorrogacaoAutomaticaCalendario(TPPRORROG,NRDIAS);
        Assert.assertEquals(calendarioDeCardapioFlows.msgEsperadaDiasProrrogacao(),NRDIAS,"Dias prorrogação: ");;


    }


    @Test
    public void prorrogacaoAutomaticaUnidade(){
        String NRDIAS = "4";
        acessarTelaCalendario();
        String TPPRORROG = "U";
        calendarioDeCardapioFlows.prorrogacaoAutomaticaCalendario(TPPRORROG,NRDIAS);
        Assert.assertEquals(calendarioDeCardapioFlows.msgEsperadaDiasProrrogacao(),NRDIAS,"Dias prorrogação: ");;


    }

    @Test
    public void exportaCalendario(){
        String DTPREVLIBECARD = "05/01/2025";
        String QTDIAPROFIL = "2";
        String DTLIMAPROVFILI = "07/01/2025";
        String QTDIAPROMAT = "3";
        String DTLIMAPROVMATR = "10/01/2025";
        String QTDIAPRORAPROV = "6";
        String DTBASCONCUSPLAN = "01/01/2025";
        String CDUNIDADE = "0002";
        String TPEXPORTACAO = "";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.exportarCalendarioCardapio(TPEXPORTACAO,CDUNIDADE);
        Assert.assertEquals(DTPREVLIBECARD,calendarioDeCardapioFlows.validaPrevisaoLiberacao());
        Assert.assertEquals(QTDIAPROFIL,calendarioDeCardapioFlows.validaDiasAprovacao());
        Assert.assertEquals(DTLIMAPROVFILI,calendarioDeCardapioFlows.validaLimiteAprovacao());
        Assert.assertEquals(QTDIAPROMAT,calendarioDeCardapioFlows.validaDiasAprovacaoMatriz());
        Assert.assertEquals(DTLIMAPROVMATR,calendarioDeCardapioFlows.validaLimiteAprovacaoMatriz());
        Assert.assertEquals(QTDIAPRORAPROV,calendarioDeCardapioFlows.validaDiasProrrogacao());
        Assert.assertEquals(DTBASCONCUSPLAN,calendarioDeCardapioFlows.validaDataCustoBase());
    }

    @Test
    public void exportaCalendarioAgrupamento(){
        String DTPREVLIBECARD = "05/01/2025";
        String QTDIAPROFIL = "2";
        String DTLIMAPROVFILI = "07/01/2025";
        String QTDIAPROMAT = "3";
        String DTLIMAPROVMATR = "10/01/2025";
        String QTDIAPRORAPROV = "6";
        String DTBASCONCUSPLAN = "01/01/2025";
        String CDUNIDADE = "0003";
        String TPEXPORTACAO = "A";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.exportarCalendarioCardapio(TPEXPORTACAO,CDUNIDADE);
        Assert.assertEquals(DTPREVLIBECARD,calendarioDeCardapioFlows.validaPrevisaoLiberacao());
        Assert.assertEquals(QTDIAPROFIL,calendarioDeCardapioFlows.validaDiasAprovacao());
        Assert.assertEquals(DTLIMAPROVFILI,calendarioDeCardapioFlows.validaLimiteAprovacao());
        Assert.assertEquals(QTDIAPROMAT,calendarioDeCardapioFlows.validaDiasAprovacaoMatriz());
        Assert.assertEquals(DTLIMAPROVMATR,calendarioDeCardapioFlows.validaLimiteAprovacaoMatriz());
        Assert.assertEquals(QTDIAPRORAPROV,calendarioDeCardapioFlows.validaDiasProrrogacao());
        Assert.assertEquals(DTBASCONCUSPLAN,calendarioDeCardapioFlows.validaDataCustoBase());
    }

    @Test
    public void logCalendarioCardapio(){
        acessarTelaCalendario();
        calendarioDeCardapioFlows.logCalendarioCardapio();
    }

}
