package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.DiferencaComensaisCardFlows;
import com.javaseleniumtemplate.pages.DiferencaComensaisCardPage;
import org.testng.annotations.Test;

public class DiferencaComensaisCardTests extends TestBase {

    DiferencaComensaisCardPage diferencaComensaisCardPage;
    DiferencaComensaisCardFlows diferencaComensaisCardFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioDiferencaAnalitico() {
        gerarRelatorios("Diferença de Comensais no Cardápio (Analítico)");
    }

    @Test
    public void relatorioDiferencaSintetico() {
        gerarRelatorios("Diferença de Comensais no Cardápio (Sintético)");
    }

    //acessar a tela 'Diferença de Comensais no Cardápio'
    //selecionar o relatório que foi passado como parâmetro
    //selecionar o agrupamento de unidades 'Matéria Prima'
    //gerar o relatório e fechar a guia do mesmo
    //selecionar as unidades (Deposito Jabaquara e Deposito Bc 129) e serviços (Jantar, Retiradas e Solicitação)
    //selecionar os meses (Maio e Julho)
    //gerar o relatório e fechar a guia do mesmo
    public void gerarRelatorios(String nomeRelatorio) {
        diferencaComensaisCardPage = new DiferencaComensaisCardPage();
        diferencaComensaisCardFlows = new DiferencaComensaisCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        diferencaComensaisCardFlows.navegateDiferencaComenCard();
        diferencaComensaisCardPage.selecionarRelatorio(nomeRelatorio);
        diferencaComensaisCardPage.selecionarAgrupamentoUnidade();
        diferencaComensaisCardPage.gerarRelatorio();
        diferencaComensaisCardPage.selecionarUnidades();
        diferencaComensaisCardPage.selecionarServicos();
        diferencaComensaisCardPage.selecionarMeses();
        diferencaComensaisCardPage.gerarRelatorio();
    }






    //acessar a tela 'Diferença de Comensais no Cardápio'
    //clicar no mês inicial e selecionar Julho
    //clicar no mês final e selecionar Maio
    //clicar no botão relatório e verificar a mensagem que é exibida na tela informando que o mês inicial deve ser maior ou igual ao final
    @Test
    public void mesesIncorretos() {
        diferencaComensaisCardPage = new DiferencaComensaisCardPage();
        diferencaComensaisCardFlows = new DiferencaComensaisCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        diferencaComensaisCardFlows.navegateDiferencaComenCard();
        diferencaComensaisCardPage.selecionarMesesIncorretos();
    }


    //acessar a tela 'Diferença de Comensais no Cardápio'
    //clicar no botão do campo relatório, clicar no botão de todas as unidades e todos os serviços, clicar nos botões dos campos dos meses (inicial e final)
    //clicar no botão relatório e verificar a mensagem de campo obrigatório exibida nos campos (relatório, unidade, serviço, mês inicial e mês final
    @Test
    public void campoObrigatorios() {
        diferencaComensaisCardPage = new DiferencaComensaisCardPage();
        diferencaComensaisCardFlows = new DiferencaComensaisCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        diferencaComensaisCardFlows.navegateDiferencaComenCard();
        diferencaComensaisCardPage.verificarCamposObrigatorios();
    }

}
