package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmbalagemFlows;
import com.javaseleniumtemplate.pages.EmbalagemPage;
import org.testng.annotations.Test;

public class EmbalagemTests extends TestBase {

    EmbalagemPage embalagemPage;
    EmbalagemFlows embalagemFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Embalagem'
    //clicar no botão adicionar, preencher o formulário para adicionar uma embalagem com o código 1
    //clicar em salvar e verificar a mensagem que é exibida na tela informando que o registro já existe
    //clicar no botão ok
    @Test
    public void codigoJaExistente() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.tentarAddCodigoExistente();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 1
    //clicar no check-box da embalagem encontrada, clicar no botão excluir
    //verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem exibida na tela informando que a exclusão não é permitida, por o registro possuí registros filhos
    //clicar em ok
    @Test
    public void tentarExcluirEmbagemComRegFilhos() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.tentarExcluirEmbaComRegistrosFilhos();
    }


    //acessar a tela 'Embalagem'
    //clicar no botão adicionar
    //preencher os campos código, embalagem, tipo, propósito, categoria, unidade, capacidade e tara
    //clicar no botão salvar, clicar em voltar
    //pesquisar pelo código da embalagem adicionada
    //verificar se as informações foram salvas corretamente
    //clicar no check-box da embalagem adicionada, clicar no botão excluir
    //verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem de excluído com sucesso, exibida no canto da tela
    //verificar se no grid é informado que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirEmbalagem() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.adicionar();
        embalagemPage.excluir();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 8
    //clicar no nome da embalagem, clicar em editar
    //alterar o nome da embalagem, a capacidade, o tara, a categoria e a unidade
    //clicar no botão salvar, clicar em voltar
    //pesquisar novamente procurando pela embalagem de código 8
    //verificar se as informações foram salvas corretamente
    //clicar no nome da embalagem e alterar o valores dos campos embalagem, capacidade, tara, categoria e unidade
    //retornando os valores para os mesmos que estavam antes de editar a embalagem
    @Test
    public void editarEmabalagem() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.editarEmbalagem();
    }


    //acessar a tela 'Embalagem'
    //clicar no botão adicionar, clicar no campo tipo, verificar a lista de opções que são apresentadas e clicar no botão voltar
    //clicar no botão adicionar, clicar no campo propósito, verificar a lista de opções que são apresentadas e clicar no botão voltar
    @Test
    public void verificarListTipoEProposito() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.verificarListTipo();
        embalagemPage.verificarListProposito();
    }


    //acessar a tela 'Embalagem'
    //clicar no botão adicionar, clicar no botão salvar
    //verificar a mensagem de campo obrigatório nos campos código e embalagem
    @Test
    public void camposObrigatoriosAddEmbalagem() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.camposObrigatoriosAddEmbalagem();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pelo código 8
    //clicar no nome da embalagem encontrada
    //verificar se os campos código, tipo e propósito estão desabilitados
    @Test
    public void camposDesabilitadoDuranteEdicao() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.campoDesabilitadosDuranteEdicao();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pelo código 9
    //alterar os valores dos campo capacidade e tara e clicar no botão salvar alterações
    //pesquisar novamente pelo código 9
    //verificar se as alterações foram salvar corretamente
    //realizar novamente as alterações nos campos capacidade e tara, retornando os valores para os que estavam no início do teste
    @Test
    public void editPelaTelaInicial() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.editarCapacidadeTaraPelaTelaInicial();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 4
    //clicar no nome da embalagem
    //clicar na aba 'relação de embalagens transportadas'
    //clicar no botão adicionar, verificar se o campo código está desabilitado
    //clicar no campo embalagem e selecionar a embalagem 'SALADA', inserir uma quantidade e clicar em salvar
    //verificar a mensagem de salvo com sucesso que é exibida no canto da tela
    //verificar se o código, nome e quantidade da embalagem foram salvos corretamente
    //clicar no check-box da embalagem, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar no botão sim
    //verificar a mensagem de excluído com sucesso, exibida no canto da tela
    //verificar se no grid é apresenta a informação de que não há registros
    @Test
    public void adicionarRelacaoEmbalagemTrasportada() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.addRelacaoEmbalagemTransportada();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 3
    //clicar no nome da embalagem
    //clicar na aba 'relação de embalagens transportadas'
    //alterar o valor da quantidade, clicar em salvar alterações
    //verificar se a quantidade foi salva corretamente
    //alterar novamente o valor da quantidade, retornando para o valor que estava no início do teste
    @Test
    public void editarQuantRelacaoEmbalagemTransportada() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.editarQuantidadeRelacaoEmbTransportada();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 3
    //clicar no nome da embalagem
    //clicar na aba 'relação de embalagens transportadas'
    //clicar no botão adicionar, clicar no botão salvar
    //verificar a mensagem de campo obrigatório exibida nos campos código, embalagem e quantidade
    @Test
    public void campoObrigatorioRelacaoEmbTranspor() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.camposObrigatoriosAddRelacaoEmbTransportada();
    }


    //acessar a tela 'Embalagem'
    //pesquisar na tela inicial, procurando pela embalagem de código 2
    //clicar no nome da embalagem
    //clica na aba Relação de Embalagens Transportadas
    //clicar no voltar voltar
    //verificar se a aba Relação de Embalagens Transportadas, não está mais visível
    @Test
    public void testarBotaoVoltarNaAbaRelacaoEmbalagens() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.botaVoltarNaAbaRelacaoEmbalagensTransp();
    }


}
