package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmissaoCardapioDiaFlows;
import com.javaseleniumtemplate.pages.EmissaoCardapioDiaPage;
import org.testng.annotations.Test;

public class EmissaoCardapioDiaTests extends TestBase {

    EmissaoCardapioDiaPage emissaoCardapioDiaPage;
    EmissaoCardapioDiaFlows emissaoCardapioDiaFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAlergenicos() {
        emitirCardapio("Cardápio do Dia - Alergênicos");
    }

    @Test
    public void relatorioDiaPorData() {
        emitirCardapio("Cardápio do Dia (por Data)");
    }

    @Test
    public void relatorioDiaPorServico() {
        emitirCardapio("Cardápio do Dia (por Serviço)");
    }

    @Test
    public void relatorioEmissaoCardapio() {
        emitirCardapio("Emissão do Cardápio");
    }


    //acessar a tela 'Emissão do Cardápio do Dia'
    //selecionar o relatório que é passado como parâmetro, preencher a data inicial e final
    //clicar no campo unidade e selecionar a unidade Deposito BC 129
    //clicar no botão relatório, tipo pdf e confirmar, fechar a guia do relatório que é gerada
    //clicar no check-box 'Todos' serviço, clicar no campo serviço, selecionar os serviços 'RETIRADAS' e 'SOLICITACAO', clicar em ok
    //clicar no botão relatório, tipo pdf e confirmar, fechar a guia do relatório que é gerada
    public void emitirCardapio(String nomeRelatorio) {
        emissaoCardapioDiaPage = new EmissaoCardapioDiaPage();
        emissaoCardapioDiaFlows = new EmissaoCardapioDiaFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "30/09/2022";

        loginFlows.efetuarLogin();
        emissaoCardapioDiaFlows.navegateEmissaoCardapioDia();
        emissaoCardapioDiaPage.selecionaRelatorio(nomeRelatorio);
        emissaoCardapioDiaPage.selecionarUnidadeDepositoBc129();
        emissaoCardapioDiaPage.preencherDatas(dataInicial, dataFinal);
        emissaoCardapioDiaPage.geraRelatorio();
        emissaoCardapioDiaPage.selecionarServicos();
        emissaoCardapioDiaPage.geraRelatorio();
    }

    
    //acessar a tela 'Emissão do Cardápio do Dia'
    //clicar no botão dos campos: relatório, unidade e intervalo de data, clicar no check-box 'Todos' do campo serviço
    //clicar no botão relatório, verificar a mensagem de campo obrigatório nos campos: relatório, unidade, intervalo de data e serviço
    //atualizar a página, clicar no check-box 'Imprimir Mensagem' e verificar se o check-box 'Quebra de Página' fica desabilitado
    //atualizar a página, verificar se o check-box 'Considerar Pratos Opção' não está sendo apresentado na tela, clicar no check-box 'Imprimir Nutrientes' e verificar se a 'Considerar Pratos Opção' passa a ser exibida na tela
    //atualizar a página, verificar se o check-box 'Quebra de Página' está selecionado, clicar no check-box e verificar se o mesmo passa a não estar mais selecionado
    //clicar nos check-box 'Imprimir Mensagem', 'Imprimir Nome Fantasia', 'Imprimir NDPCAL', e 'Imprimir Nutrientes'
    //verificar se as opções: imprimir mensagem, imprimir nome fantasia, imprimir NDPCAL, imprimir nutrientes e considerar pratos opção, passão a estar selecionados
    //clicar no check-box de considerar pratos opção e verificar se o mesmo passa a não estar mais selecionado
    //atualizar a página selecionar um relatório de cada vez e verificar se os check-box imprimir mensagem, imprimir nome fantasia, imprimir NDPCAL e imprimir nutriente, estão habilitado ou não, de acordo com o relatório selecionado
    @Test
    public void testesComplementares() {
        emissaoCardapioDiaPage = new EmissaoCardapioDiaPage();
        emissaoCardapioDiaFlows = new EmissaoCardapioDiaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioDiaFlows.navegateEmissaoCardapioDia();
        emissaoCardapioDiaPage.camposObrigatorios();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.desabilitarCheckBoxQuebraPagia();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.habilitarConsiderarPratosOpcoes();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.verificarCheckBoxSelecionados();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.verificarCamposHabilitadosPeloRelatorios();
    }

}
