package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PadraoServicoFlows;
import com.javaseleniumtemplate.pages.PadraoServicoPage;
import org.testng.annotations.Test;

public class PadraoServicoTests extends TestBase {

    PadraoServicoPage padraoServicoPage;
    PadraoServicoFlows padraoServicoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Padrão de Serviço'
    //clicar no botão adicionar, preencher os campos: código e nome
    //clicar no botão do campo 'nome produto', procurar por 101110200700, clicar no produto CARBONATO DE BARIO
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //no filtro da tela inicial procurar por 00004, verificar se as informações (código, nome, produto, nome produto) do padrão adicionado foram salvos corretamente
    //no filtro da tela inicial procurar por 00004, clicar no check-box do padrão de serviço encontrado, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    @Test
    public void adicionarExcluirPadraoServico() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.addPadraoServico();
        padraoServicoPage.verificarPadraoServicoAdd();
        padraoServicoPage.excluirPadraoServico();
    }


    //acessar a tela 'Padrão de Serviço'
    //no filtro da tela inicial procurar por 00003, clicar no código do padrão de serviço, clicar em editar
    //verificar se o campo código está desabilitado, alterar o nome do padrão de serviço, clicar no botão do campo nome produto, para limpar o produto que estava selecionado
    //clicar novamente no botão do campo nome produto, procurar pelo código 101110201000, clicar no produto CLORETO DE SODIO
    //clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se as informações (código, nome, produto e nome produto) do padrão serviço alterado foram salvas corretamente
    //refazer o processo de clicar no código do produto, clicar em editar, alterar o nome, alterar o produto, clicar em salvar
    //retornando os valores para os que estavam no início do teste
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    @Test
    public void editarAcessandoPadraoServico() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.editarAcessandoPadraoServico();
    }


    //acessar a tela 'Padrão de Serviço'
    //no filtro da tela inicial procurar por 00003, clicar no botão editar no inline do padrão de serviço encontrado
    //verificar se o campo código está desabilitado, alterar o nome do padrão de serviço, clicar no botão do campo nome produto, para limpar o produto que estava selecionado
    //clicar novamente no botão do campo nome produto, procurar pelo código 101110201000, clicar no produto CLORETO DE SODIO
    //clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se as informações (código, nome, produto e nome produto) do padrão de serviço alterado foram salvas corretamente
    //refazer o processo de clicar no código do produto, clicar em editar, alterar o nome, alterar o produto, clicar em salvar
    //retornando os valores para os que estavam no início do teste
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    @Test
    public void editarPadraoServicoBotaoTelaInicial() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.editarPadraoServicoBotaoTelaInicial();
    }


    //acessar a tela 'Padrão de Serviço'
    //no filtro da tela inicial procurar por 00003, alterar o nome do padrão de serviço para RECEBIMENTO, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela, verificar se o nome foi salvo corretamente
    //alterar novamente o nome do padrão de serviço agora para RECEBER, clicar em salvar, verificar a mensagem de salvo com sucesso
    //verificar se o nome foi salvo corretamente, após retornar para o nome que estava no início do teste
    @Test
    public void alterarNomePadraoServico() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.alterarNomePadraoServico();
    }


    //acessar a tela 'Padrão de Serviço'
    //clicar no botão adicionar, preencher os campos: código e nome
    //clicar no botão do campo 'nome produto', procurar por 101110200700, clicar no produto CARBONATO DE BARIO
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //no filtro procurar por 00004, clicar no botão excluir do inline do padrão de serviço encontrado
    //verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    @Test
    public void excluirPadraoServicoBotaoTelaInicial() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.addPadraoServico();
        padraoServicoPage.excluirPadraoServicoBotaoTelaInicial();
    }


    //acessar a tela 'Padrão de Serviço'
    //adicionar 2 padrões de serviços 'DISTRIBUIÇÃO' e 'RECEBIMENTOS ATRASADOS'
    //no filtro procurar pelo código 00004, clicar no check-box do padrão de serviço encontrado
    //no filtro procurar pelo código 00005, clicar no check-box do padrão de serviço encontrado
    //clicar no botão 'excluir selecionados', verificar a mensagem exibida na tela, clicar em sim
    //verifica mensagem de excluído com sucesso exibida no canto superior direito da tela
    @Test
    public void excluirDoisPadroesDeServico() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.addPadraoServico();
        padraoServicoPage.adicionarSegundoPadraoDeServico();
        padraoServicoPage.excluirPadroesServicosSelecionados();
    }


    //acessar a tela 'Padrão de Serviço'
    //clicar no botão adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: código, nome, produto e nome produto, clicar em cancelar
    //no filtro procurar pelo código 00002, apagar o nome do padrão de serviço encontrado, deixando o campo vazio, clicar em salvar alterações
    //verificar a mensagem exibida na tela informando para preencher o nome, clicar em ok, clicar em cancelar
    //verificar se após clicar em cancelar, o nome que estava salvo anteriormente não foi alterado
    @Test
    public void camposObrigatorios() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.camposObrigatorios();
        padraoServicoPage.tentarSalvarEdicaoCampoNomeVazio();
    }


    //acessar a tela 'Padrão de Serviço'
    //clicar no botão adicionar, preencher o código com valor 1, preencher o nome, selecionar um produto
    //clicar em salvar, verificar a mensagem exibida no canto superior direito da tela informando que o registro já existe
    //clicar em cancelar
    @Test
    public void tentarAdicionarPadraoCodigoExistente() {
        padraoServicoPage = new PadraoServicoPage();
        padraoServicoFlows = new PadraoServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoServicoFlows.navegateTelaPadraoServico();
        padraoServicoPage.registroJaExiste();
    }

}
