package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PratoXPorcionamentoFlows;
import com.javaseleniumtemplate.pages.PratoXPorcionamentoPage;
import org.testng.annotations.Test;

public class PratoXPorcionamentoTests extends TestBase {

    PratoXPorcionamentoPage pratoXPorcionamentoPage;
    PratoXPorcionamentoFlows pratoXPorcionamentoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Prato X Porcionamento'
    //clicar no botão adicionar, clicar no campo prato, selecionar 2 pratos, clicar no botão ok
    //clicar no campo porcionamento, selecionar o porcionamento 'colher de sopa', preencher o campo quantidade, clicar em salvar
    //verificar mensagem de registro adicionado com sucesso, exibida no canto da tela após adicionar um novo prato x porcionamento
    //procurar na tela inicial pelo código 000000001
    //verificar se o código, nome e unidade, são de um dos 2 pratos que foram adicionados
    //clicar no código do prato, verificar se o nome e quantidade do porcionamento correspondem aos valores adicionados, clicar no botão voltar
    //procurar na tela inicial pelo código 000000002
    //verificar se o código, nome e unidade, são de um dos 2 pratos que foram adicionados
    //clicar no código do prato, verificar se o nome e quantidade do porcionamento correspondem aos valores adicionados, clicar no botão voltar
    //procurar na tela inicial pelo código 000000001, clicar no código do prato, clicar no botão excluir do porcionamento
    //verificar a mensagem exibida na tela após clicar para excluir o porcionamento, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    //procurar na tela inicial pelo código 000000002, clicar no código do prato, clicar no botão excluir do porcionamento
    //verificar a mensagem exibida na tela após clicar para excluir o porcionamento, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarExcluirPratoXPorcionamento() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.adicionarPratoXPorcionamento();
        pratoXPorcionamentoPage.verificarPratoXPorcionamentoAdicionados();
        pratoXPorcionamentoPage.excluirPratoXPorcionamentoAdicionados();
    }


    //acessar a tela 'Prato X Porcionamento'
    //procurar na tela inicial pelo código 000000002
    //clicar no nome do prato, alterar a quantidade do porcionamento para 7, clicar em salvar
    //verificar a mensagem de alteração realizada com sucesso, exibida no canto da tela
    //atualizar a página, procurar na tela inicial pelo código 000000002
    //clicar no nome do prato, verificar se o porcionamento foi salvo corretamente
    //alterar a quantidade de porcionamento para 9, retornando para o valor que estava no início do teste
    //clicar em salvar, verificar se o valor foi salvo corretamente
    @Test
    public void editarQuantidadePorcionamento() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.editarQuantidadePorcionamento();
    }


    //acessar a tela 'Prato X Porcionamento'
    //procurar na tela inicial pelo código 000000000
    //clicar no nome do prato, clicar no botão adicionar, clicar no campo porcionamento, selecionar a 'colher de chá'
    //preencher a quantidade com 8, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se o nome do porcionamento e a quantidade foram salvos corretamente
    //clicar no botão excluir deste porcionamento que foi adicionado, verificar a mensagem que é exibida na tela após clicar para excluir
    //clicar no botão sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarExcluirSegundoPorcionamento() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.adicionarSegundoPorcionamento();
        pratoXPorcionamentoPage.excluirSegundoPorcionamento();
    }


    //acessar a tela 'Prato X Porcionamento'
    //procurar na tela inicial pelo código 000000000
    //clicar no nome do prato, clicar no botão adicionar, clicar no campo porcionamento, selecionar a 'colher de chá'
    //preencher a quantidade com 8, clicar em salvar
    //clicar no botão adicionar, clicar no campo porcionamento, selecionar o porcionamento 'colher de chá', clicar em salvar
    //verificar mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe
    //clicar no botão ok, clicar em cancelar, clicar no botão excluir do porcionamento que foi adicionado com sucesso no início do teste
    //verificar mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    //verificar se o prato não possuí mais um segundo porcionamento
    @Test
    public void tentarAdicionarPorcionamentoJaExistente() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.tentarAdicionarUmPorcionamentoJaExiste();
    }


    //acessar a tela 'Prato X Porcionamento'
    //clicar no botão adicionar, clicar no campo prato, selecionar o prato 'ARROZ BRANCO' (este prato já está adicionar, com o porcionamento 'colher de sopa'
    //clicar em ok, clicar no campo porcionamento, selecionar o porcionamento 'colher de sopa', preencher o campo quantidade com valor 5
    //verificar a mensagem exibida na tela perguntando se deseja sobrepor o porcionamento, clicar em sim
    //procurar na tela inicial pelo código 000000005
    //verificar se não foi adicionado um segundo prato na tela, clicar no nome do prato encontrado, verificar se a quantidade do porcionamento foi alterada para o valor sobreposto
    //alterar o valor da quantidade para o valor 8 (valor que estava no início do teste), clicar em salvar, verificar se o valor foi salvo corretamente
    @Test
    public void adicionarPratoXPorcionamentoJaExistente() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.sobreescreverPratoXPorcionamentoJaExistente();
    }


    //acessar a tela 'Prato X Porcionamento'
    //clicar no botão adicionar, clicar no prato feijão, clicar em ok, clicar no campo porcionamento, selecionar o arrebatamento colher de chá
    //preencher a quantidade com valor 6, clicar no botão salvar, verificar a mensagem exibida na tela perguntando se deseja sobrepor o porcionamento, clicar em não
    //clicar em cancelar, procurar na tela inicial pelo código 000000004, verificar se o produto encontrado é o 'FEIJAO', verificar se não foi adicionado um segundo prato
    //clicar no nome do prato, verificar se a quantidade não foi alterada
    @Test
    public void naoSobreescreverPratoXPorcionamentoExistente() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.naoSobreescreverPorcionamento();
    }


    //acessar a tela 'Prato X Porcionamento'
    //clicar no botão adicionar, clicar no prato feijão, clicar em ok, clicar no campo porcionamento, selecionar o arrebatamento colher de sopa
    //preencher a quantidade com o valor 8,5 clicar no botão salvar
    //procurar na tela inicial pelo código 000000004, verificar se o produto encontrado é o 'FEIJAO', verificar se não foi adicionado um segundo prato
    //clicar no código do prato, verificar se o segundo porcionamento e a quantidade correspondem aos valores adicionados no início do teste
    //clicar no botão excluir do segundo porcionamento, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem excluído com sucesso exibida no canto da tela
    @Test
    public void addPratoComPorcionamentoDiferenteDoExistente() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.addPratoComPorcionamentoDiferenteDoExistente();
    }


    //acessar a tela 'Prato X Porcionamento'
    //clicar no botão adicionar, clicar em salvar, verificar mensagem de campo obrigatório nos campos: prato, porcionamento e quantidade
    //clicar em cancelar, procurar na tela inicial pelo código 000000000, clicar no código do prato, clicar em adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: porcionamento e quantidade
    //clicar em cancelar, clicar em voltar
    @Test
    public void camposObrigatorios() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.camposObrigatoriosAddPratoXPorcionamento();
        pratoXPorcionamentoPage.campoObrigatorioAddPorcionamento();
    }

}
