package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RelacaoProdutoXEmbalagemFlows;
import com.javaseleniumtemplate.pages.RelacaoProdutoXEmbalagemPage;
import org.testng.annotations.Test;

public class RelacaoProdutoXEmbalagemTests extends TestBase {

    RelacaoProdutoXEmbalagemPage relacaoProdutoXEmbalagemPage;
    RelacaoProdutoXEmbalagemFlows relacaoProdutoXEmbalagemFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Relação Produto x Embalagem'
    //no filtro inicial procurar pela embalagem MARMITÉX, acessar a embalagem, clicar no botão adicionar, clicar no botão do campo produto
    //procurar pelo código do produto OLEO DE COPAIBA e selecionar o mesmo, preencher a quantidade do produto, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se as informações (código, nome, unidade e quantidade) do produto foram salvos corretamente, clicar em voltar
    //clicar na aba embalagem por produto, no filtro inicial procurar pelo código do produto OLEO DE COPAIBA e selecionar o mesmo
    //verificar se as informações (código, nome e capacidade) da embalagem MARMITÉX foram salvas corretamente no produto
    //clicar no check-box da embalagem, clicar no botão excluir, verificar a mensagem exibida na tela após clicar para excluir a embalagem
    //clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    //verificar se no grid da lista de embalagens é exibida a mensagem de não há registros
    //clicar no botão voltar, clicar na aba produto por embalagem, no filtro inicial procurar pela embalagem MARMITÉX
    //acessar a embalagem e verificar se é exibida no grid da lista de produtos, a mensagem de não há registros
    @Test
    public void teste01() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.addProdutoNaEmbalagemMarmitex();
        relacaoProdutoXEmbalagemPage.conferirProdutoAddNaEmbalagem();
        relacaoProdutoXEmbalagemPage.excluirEmbalagemAbaEmbPorProduto();
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //clicar na aba embalagem por produto, no filtro inicial procurar pela código do produto BISSULFATO DE POTASSIO e selecionar o mesmo
    //clicar no botão adicionar, clicar no campo embalagem e selecionar a embalagem PANELA, preencher a capacidade e clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela, verificar se as informações (código, nome e capacidade) da embalagem foram salvos corretamente no produto
    //clicar em voltar, clicar na aba produto por embalagem, no filtro inicial procurar pela embalagem PANELA
    //verificar se as informações (código, nome, unidade e quantidade) do produto foram salvas corretamente na embalagem
    //clicar no check-box do produto, clicar no botão excluir, verificar a mensagem exibida na tela após clicar para excluir o produto
    //clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    //verificar se no grid da lista de produtos é exibida a mensagem de não há registros
    //clicar em voltar, clicar na aba embalagem por produto, no filtro procurar pelo código do produto BISSULFATO DE POTASSIO e selecionar o mesmo
    //verificar se no no grid da lista de embalagens é exibida a mensagem de não há registros
    @Test
    public void teste02() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.addEmbalagemNoProdutoBissulfatoPotassio();
        relacaoProdutoXEmbalagemPage.conferirEmbalagemAddNoProduto();
        relacaoProdutoXEmbalagemPage.excluirProdutoAbaProdPorEmbalagem();
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //clicar na aba produto por embalagem, no filtro procurar pela embalagem POTE DESCARTÁVEL e acessar a mesma
    //alterar a quantidade do produto para o valor que foi passado como parâmetro, clicar em 'salvar alterações'
    //verificar a mensagem de salvo com sucesso exibida no canto da tela, verificar se a nova quantidade foi salva corretamente, clicar em voltar
    //clicar na aba embalagem por produto, no filtro procurar pelo código do produto IODETO DE ARSENIO e acessar o mesmo
    //verificar se a capacidade da embalagem no produto também foi alterada para o valor que foi passado como parâmetro, clicar em voltar
    //refazer o processo, passando uma nova quantidade como parâmetro, acessar a embalagem, alterar o valor, clicar em salvar
    //verificar a mensagem de salvo com sucesso, verificar se a quantidade foi salva corretamente
    //acessar o produto e verificar se a capacidade da embalagem também foi alterada
    @Test
    public void teste03() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        String quantInicial = "2,50000";
        String quantAlterada = "6,00000";

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.editarQuantidadeProduto(quantInicial);
        relacaoProdutoXEmbalagemPage.editarQuantidadeProduto(quantAlterada);
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //clicar na aba embalagem por produto, no filtro procurar pelo código do produto OXIDO DE CALCIO e acessar o mesmo
    //alterar a capacidade da embalagem para o valor que foi passado como parâmetro, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela, verificar se a nova capacidade da embalagem foi salva corretamente
    //clicar em voltar, clicar na aba produto por embalagem, no filtro procurar pela embalagem PLÁSTICO e acessar a mesma
    //verificar se a quantidade do produto também foi alterada para o valor que foi passado como parâmetro, clicar em voltar
    //refazer o processo, clicando na aba embalagem por produto, acessando o produto OXIDO DE CALCIO, alterar a capacidade da embalagem
    //clicar em salvar, verificar a mensagem de salvo com sucesso, ir até a embalagem e verificar se a quantidade do produto também foi alterada
    @Test
    public void teste04() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        String capacidadeInicial = "4,00000";
        String capacidadeAlterada = "7,20000";

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.editarCapacidadeEmbalagemNoProduto(capacidadeAlterada);
        relacaoProdutoXEmbalagemPage.editarCapacidadeEmbalagemNoProduto(capacidadeInicial);
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //acessar a embalagem MARMITÉX, clicar no botão adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos (produto e quantidade) e verificar a mensagem de valor mínimo no campo quantidade
    //clicar em cancelar, clicar em voltar
    //acessar a aba embalagem por produto, acessar o produto OLEO DE COPAIBA, clicar no botão adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos (embalagem e capacidade) e verificar a mensagem de valor mínimo no campo capacidade
    //clicar em cancelar, clicar em voltar
    //clicar no botão 'Cad. Automático', clicar no botão do campo produto inicial, procurar pelo código do produto CREOSOTO e selecionar o mesmo
    //clicar no botão do campo produto inicial, para apagar o produto que havia sido selecionado
    //verificar a mensagem de campo obrigatório nos campos (produto inicial, produto final e embalagem), clicar em voltar
    @Test
    public void teste05() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.verificarCamposObrigatoriosAddProdutoNaEmb();
        relacaoProdutoXEmbalagemPage.verificarCamposObrigatoriosAddEmbalagemNoProd();
        relacaoProdutoXEmbalagemPage.verificarCamposObrigatoriosCadAuto();
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //no filtro inicial procurar pela embalagem VIDRO, clicar no botão adicionar, clicar no botão do campo produto
    //procurar pelo código do produto GRAFITE e selecionar o mesmo, preencher a quantidade e clicar em salvar
    //verificar a mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe, clicar em ok, clicar em cancelar, clicar em voltar
    //clicar na aba embalagem por produto, no filtro procurar pelo código do produto NITRATO DE PRATA e acessar o mesmo
    //clicar no botão adicionar, clicar no campo embalagem e selecionar a embalagem VIDRO, preencher a capacidade e clicar em salvar
    //verificar a mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe, clicar em ok, clicar em cancelar, clicar em voltar
    @Test
    public void teste06() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.tentarAddProdutoJaExistenteNaEmb();
        relacaoProdutoXEmbalagemPage.tentarAddEmbalagemJaExistenteNoProd();
    }


    //acessar a tela 'Relação Produto x Embalagem'
    //no filtro procurar pela embalagem MADEIRA, adicionar a está embalagem os produtos OLEO DE COPAIBA e OLEO DE CASTANHA DO BRASIL, clicar em voltar
    //no filtro procurar pela embalagem MADEIRA, pegar o valor da capacidade da embalagem e armazenar em uma variável
    //clicar no botão 'Cad. Automático', clicar no botão do campo produto inicial, procurar pelo código do produto CREOSOTO e selecionar o mesmo
    //clicar no botão do campo produto final, procurar pelo código do produto OLEO DE COPAIBA e selecionar o mesmo
    //clicar no campo embalagem, selecionar a embalagem MADEIRA, clicar no botão ok
    //verificar se a quantidade de produtos apresentados no grid após o filtro dos produtos inicial e final, correspondem à 3 produtos
    //verificar se as informações (código, produto, unidade) correspondem aos produto CREOSOTO, OLEO DE CASTANHA DO BRASIL e OLEO DE COPAIBA
    //verificar se a embalagem apresentada nos 3 produto é a embalagem MADEIRA e se a quantidade, corresponde à capacidade da embalagem MADEIRA que foi armazenada em uma variável
    //clicar no check-box do primeiro e segundo produtos do grid, os produtos (CREOSOTO e OLEO DE CASTANHA DO BRASIL)
    //clicar em confirmar, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de sucesso exibida no canto da tela
    //clicar em voltar, clicar na embalagem MADEIRA, verificar se a quantidade de produtos na embalagem é igual à 3
    //verificar as informações (código, produto, unidade e quantidade) dos 3 produtos
    //o produto CREOSOTO que não havia sido adicionado no início do teste deve ter sido adicionado
    //o produto OLEO DE CASTANHA DO BRASIL já estava na embalagem e deve ter tido a sua quantidade alterada para o valor da capacidade da embalagem e o produto OLEO DE COPAIBA já estava na embalagem e não deve ter tido a sua quantidade alterada
    //após verificar as informações dos 3 produtos, clicar no check-box para selecionar todos os produtos da embalagem
    //clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void teste07() {
        relacaoProdutoXEmbalagemPage = new RelacaoProdutoXEmbalagemPage();
        relacaoProdutoXEmbalagemFlows = new RelacaoProdutoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoProdutoXEmbalagemFlows.navegateTelaProdutoXEmbalagem();
        relacaoProdutoXEmbalagemPage.addProdutoAEmbalagemParaTestCadAuto();
        relacaoProdutoXEmbalagemPage.cadastroAuto();
        relacaoProdutoXEmbalagemPage.excluirTodosProdutosDaEmbalagem();
    }

}